(function (Drupal, once, window) {
  Drupal.behaviors.vlsuite_collection_gallery = {
    attach(context) {
      once(
        'vlsuite-collection-gallery-slides-sync',
        '.vlsuite-block__vlsuite-collection-gallery .vlsuite-layout',
        context,
      ).forEach(slidesSync);
    },
  };

  /**
   * Collection gallery slides sync.
   */
  function slidesSync(initElement) {
    if (
      initElement.querySelectorAll(
        '.vlsuite-block__block-contentvlsuite-collection-galleryvlsuite-medias',
      ).length !== 2 ||
      typeof window.Swiper !== 'function'
    ) {
      return;
    }
    const main = initElement.querySelectorAll(
      '.vlsuite-block__block-contentvlsuite-collection-galleryvlsuite-medias',
    )[0];
    const mainSlide = main.querySelector('.swiper');
    const thumbnails = initElement.querySelectorAll(
      '.vlsuite-block__block-contentvlsuite-collection-galleryvlsuite-medias',
    )[1];
    const thumbnailsSlide = thumbnails.querySelector('.swiper');
    if (
      typeof mainSlide === 'object' &&
      typeof mainSlide.swiper === 'object' &&
      typeof thumbnailsSlide === 'object' &&
      typeof thumbnailsSlide.swiper === 'object'
    ) {
      mainSlide.swiper.thumbs.swiper = thumbnailsSlide.swiper;
      mainSlide.swiper.thumbs.init();
      thumbnailsSlide.swiper.slideTo(mainSlide.swiper.activeIndex);
      mainSlide.swiper.on('slideChange', function () {
        thumbnailsSlide.swiper.slideTo(mainSlide.swiper.activeIndex);
      });
      thumbnails.classList.add('swiper-sync-active');
    }
  }
})(Drupal, once, window);
