(function ($, Drupal, once, window) {
  Drupal.behaviors.vlsuite_utility_classes_previewer = {
    attach(context) {
      once(
        'vlsuite-utility-classes__previewer',
        '.vlsuite-utility-classes .vlsuite-utility-classes__previewer',
        context,
      ).forEach(utilityClassesPreviewer);
    },
  };

  /**
   * Utility classes previewer.
   */
  function utilityClassesPreviewer(previewBox) {
    const appliedKeysClasses = {};
    $(
      '.vlsuite-utility-classes .vlsuite-utility-classes__previewer-option',
    ).change(function (e) {
      const utilityClasses = $(event.target).data('class');
      const classToApply = String(utilityClasses[event.target.value]);
      const classesKey = $(event.target).data('class-key');
      if (classToApply && classToApply.length) {
        if (appliedKeysClasses[classesKey] !== undefined) {
          $(previewBox).removeClass(appliedKeysClasses[classesKey]);
        }
        appliedKeysClasses[classesKey] = classToApply;
        $(previewBox).addClass(classToApply);
      } else {
        $(previewBox).removeClass(appliedKeysClasses[classesKey]);
        delete appliedKeysClasses[classesKey];
      }
    });
  }
})(jQuery, Drupal, once, window);
